diff --git a/oflog/include/dcmtk/oflog/hierarchy.h b/oflog/include/dcmtk/oflog/hierarchy.h
index 0121ab2..652b64c 100644
--- a/oflog/include/dcmtk/oflog/hierarchy.h
+++ b/oflog/include/dcmtk/oflog/hierarchy.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    hierarchy.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,17 +21,20 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_HIERARCHY_HEADER_
-#define DCMTK__LOG4CPLUS_HIERARCHY_HEADER_
+#ifndef DCMTK_LOG4CPLUS_HIERARCHY_HEADER_
+#define DCMTK_LOG4CPLUS_HIERARCHY_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/logger.h"
-#include "dcmtk/oflog/helpers/lloguser.h"
-#include "dcmtk/oflog/helpers/pointer.h"
-#include "dcmtk/oflog/helpers/threads.h"
-//#include <map>
-//#include <memory>
-//#include <vector>
+#include "dcmtk/oflog/thread/syncprim.h"
+#include "dcmtk/ofstd/ofmap.h"
+#include <memory>
+#include "dcmtk/ofstd/ofvector.h"
 
 
 namespace dcmtk {
@@ -57,7 +61,8 @@ namespace log4cplus {
      * to the provision node. Other descendants of the same ancestor add
      * themselves to the previously created provision node.
      */
-    class DCMTK_LOG4CPLUS_EXPORT Hierarchy : protected helpers::LogLogUser {
+    class DCMTK_LOG4CPLUS_EXPORT Hierarchy
+    {
     public:
         // DISABLE_OFF should be set to a value lower than all possible
         // priorities.
@@ -78,25 +83,25 @@ namespace log4cplus {
          * This call will clear all logger definitions from the internal
          * hashtable. Invoking this method will irrevocably mess up the
          * logger hierarchy.
-         *
+         *                     
          * You should <em>really</em> know what you are doing before
          * invoking this method.
          */
         virtual void clear();
 
         /**
-         * Returns <code>true </code>if the named logger exists
+         * Returns <code>true </code>if the named logger exists 
          * (in the default hierarchy).
-         *
+         *                
          * @param name The name of the logger to search for.
          */
-        virtual bool exists(const tstring& name);
+        virtual bool exists(const log4cplus::tstring& name);
 
         /**
          * Similar to {@link #disable(LogLevel)} except that the LogLevel
-         * argument is given as a tstring.
+         * argument is given as a log4cplus::tstring.  
          */
-        virtual void disable(const tstring& loglevelStr);
+        virtual void disable(const log4cplus::tstring& loglevelStr);
 
         /**
          * Disable all logging requests of LogLevel <em>equal to or
@@ -104,11 +109,9 @@ namespace log4cplus {
          * <em>all</em> loggers in this hierarchy. Logging requests of
          * higher LogLevel then <code>p</code> remain unaffected.
          *
-         * Nevertheless, if the {@link
-         * BasicConfigurator#DISABLE_OVERRIDE_KEY} system property is set to
-         * "true" or any value other than "false", then logging requests are
-         * evaluated as usual, i.e. according to the <a
-         * href="../../../../manual.html#selectionRule">Basic Selection Rule</a>.
+         * Nevertheless, if the
+         * BasicConfigurator::DISABLE_OVERRIDE_KEY property is set to
+         * true, then logging requests are evaluated as usual.
          *
          * The "disable" family of methods are there for speed. They
          * allow printing methods such as debug, info, etc. to return
@@ -151,41 +154,41 @@ namespace log4cplus {
 
         /**
          * Return a new logger instance named as the first parameter using
-         * the default factory.
-         *
+         * the default factory. 
+         *                
          * If a logger of that name already exists, then it will be
          * returned.  Otherwise, a new logger will be instantiated and
          * then linked with its existing ancestors as well as children.
-         *
+         *                                    
          * @param name The name of the logger to retrieve.
          */
-        virtual Logger getInstance(const tstring& name);
+        virtual Logger getInstance(const log4cplus::tstring& name);
 
         /**
          * Return a new logger instance named as the first parameter using
          * <code>factory</code>.
-         *
+         *                
          * If a logger of that name already exists, then it will be
          * returned.  Otherwise, a new logger will be instantiated by the
          * <code>factory</code> parameter and linked with its existing
          * ancestors as well as children.
-         *
+         *                                         
          * @param name The name of the logger to retrieve.
          * @param factory The factory that will make the new logger instance.
          */
-        virtual Logger getInstance(const tstring& name, spi::LoggerFactory& factory);
+        virtual Logger getInstance(const log4cplus::tstring& name, spi::LoggerFactory& factory);
 
         /**
          * Returns all the currently defined loggers in this hierarchy.
          *
-         * The root logger is <em>not</em> included in the returned list.
+         * The root logger is <em>not</em> included in the returned list. 
          */
         virtual LoggerList getCurrentLoggers();
 
-        /**
-         * Is the LogLevel specified by <code>level</code> enabled?
+        /** 
+         * Is the LogLevel specified by <code>level</code> enabled? 
          */
-        virtual bool isDisabled(int level);
+        virtual bool isDisabled(LogLevel level);
 
         /**
          * Get the root of this hierarchy.
@@ -205,22 +208,22 @@ namespace log4cplus {
          * This method should be used sparingly and with care as it will
          * block all logging until it is completed.</p>
          */
-        virtual void resetConfiguration();
+        virtual void resetConfiguration(); 
 
         /**
          * Set the default LoggerFactory instance.
          */
         virtual void setLoggerFactory(OFauto_ptr<spi::LoggerFactory> factory);
-
+        
         /**
          * Returns the default LoggerFactory instance.
          */
-        virtual spi::LoggerFactory* getLoggerFactory() { return defaultFactory.get(); }
+        virtual spi::LoggerFactory* getLoggerFactory();
 
         /**
          * Shutting down a hierarchy will <em>safely</em> close and remove
          * all appenders in all loggers including the root logger.
-         *
+         *                
          * Some appenders such as SocketAppender need to be closed before the
          * application exits. Otherwise, pending logging events might be
          * lost.
@@ -234,25 +237,26 @@ namespace log4cplus {
 
     private:
       // Types
-        typedef OFList<Logger> ProvisionNode;
-        typedef OFListIterator(Logger) ProvisionNodeIterator;
-        typedef OFMap<tstring, ProvisionNode> ProvisionNodeMap;
-        typedef OFMap<tstring, Logger> LoggerMap;
+        typedef OFVector<Logger> ProvisionNode;
+        typedef OFMap<log4cplus::tstring, ProvisionNode> ProvisionNodeMap;
+        typedef OFMap<log4cplus::tstring, Logger> LoggerMap;
 
       // Methods
         /**
          * This is the implementation of the <code>getInstance()</code> method.
          * NOTE: This method does not lock the <code>hashtable_mutex</code>.
          */
-        virtual Logger getInstanceImpl(const tstring& name,
-                                       spi::LoggerFactory& factory);
-
+        DCMTK_LOG4CPLUS_PRIVATE
+        virtual Logger getInstanceImpl(const log4cplus::tstring& name, 
+            spi::LoggerFactory& factory);
+        
         /**
          * This is the implementation of the <code>getCurrentLoggers()</code>.
          * NOTE: This method does not lock the <code>hashtable_mutex</code>.
          */
+        DCMTK_LOG4CPLUS_PRIVATE
         virtual void initializeLoggerList(LoggerList& list) const;
-
+        
         /**
          * This method loops through all the *potential* parents of
          * logger'. There 3 possible cases:
@@ -273,7 +277,7 @@ namespace log4cplus {
          *
          *    We add 'logger' to the list of children for this potential parent.
          */
-        void updateParents(Logger logger);
+        DCMTK_LOG4CPLUS_PRIVATE void updateParents(Logger const & logger);
 
         /**
          * We update the links for all the children that placed themselves
@@ -289,31 +293,35 @@ namespace log4cplus {
          *   Otherwise, we set logger's parent field to c's parent and set
          *   c's parent field to logger.
          */
-        void updateChildren(ProvisionNode& pn, Logger logger);
+        DCMTK_LOG4CPLUS_PRIVATE void updateChildren(ProvisionNode& pn,
+            Logger const & logger);
 
-    // Data
-       DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE hashtable_mutex;
-       OFauto_ptr<spi::LoggerFactory> defaultFactory;
-       ProvisionNodeMap provisionNodes;
-       LoggerMap loggerPtrs;
-       Logger root;
+     // Data
+        thread::Mutex hashtable_mutex;
+        OFauto_ptr<spi::LoggerFactory> defaultFactory;
+        ProvisionNodeMap provisionNodes;
+        LoggerMap loggerPtrs;
+        Logger root;
 
-       int disableValue;
+        int disableValue;
 
-       bool emittedNoAppenderWarning;
-       bool emittedNoResourceBundleWarning;
+        bool emittedNoAppenderWarning;
 
-     // Disallow copying of instances of this class
-       Hierarchy(const Hierarchy&);
-       Hierarchy& operator=(const Hierarchy&);
+        // Disallow copying of instances of this class
+        Hierarchy(const Hierarchy&);
+        Hierarchy& operator=(const Hierarchy&);
 
-    // Friends
-       friend class spi::LoggerImpl;
-       friend class HierarchyLocker;
+     // Friends
+        friend class log4cplus::spi::LoggerImpl;
+        friend class log4cplus::HierarchyLocker;
     };
 
+
+    DCMTK_LOG4CPLUS_EXPORT Hierarchy & getDefaultHierarchy ();
+
+
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_HIERARCHY_HEADER_
+#endif // DCMTK_LOG4CPLUS_HIERARCHY_HEADER_
 
diff --git a/oflog/include/dcmtk/oflog/hierlock.h b/oflog/include/dcmtk/oflog/hierlock.h
index d461de6..ccecf6b 100644
--- a/oflog/include/dcmtk/oflog/hierlock.h
+++ b/oflog/include/dcmtk/oflog/hierlock.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
-// File:    hierarchylocker.h
+// File:    hierlock.h
 // Created: 8/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,14 +21,27 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_HIERARCHY_LOCKER_HEADER_
-#define DCMTK__LOG4CPLUS_HIERARCHY_LOCKER_HEADER_
+#ifndef DCMTK_LOG4CPLUS_HIERARCHY_LOCKER_HEADER_
+#define DCMTK_LOG4CPLUS_HIERARCHY_LOCKER_HEADER_
 
-#include "dcmtk/oflog/hierarchy.h"
+#include "dcmtk/oflog/config.h"
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/tstring.h"
+#include "dcmtk/oflog/appender.h"
+#include "dcmtk/oflog/logger.h"
+
+
+namespace dcmtk
+{
+namespace log4cplus
+{
+
+    class Hierarchy;
 
-namespace dcmtk {
-namespace log4cplus {
 
     /**
      * This is used to lock a Hierarchy.  The dtor unlocks the Hierarchy.
@@ -37,33 +51,33 @@ namespace log4cplus {
       // ctor & dtor
         HierarchyLocker(Hierarchy& h);
         ~HierarchyLocker();
-
+        
         /**
          * Calls the <code>resetConfiguration()</code> method on the locked Hierarchy.
          */
-        void resetConfiguration();
-
+        void resetConfiguration(); 
+        
         /**
          * Calls the <code>getInstance()</code> method on the locked Hierarchy.
          */
-        Logger getInstance(const tstring& name);
-
+        Logger getInstance(const log4cplus::tstring& name);
+        
         /**
          * Calls the <code>getInstance()</code> method on the locked Hierarchy.
          */
-        Logger getInstance(const tstring& name, spi::LoggerFactory& factory);
-
-        void addAppender(Logger &logger, SharedAppenderPtr& appender);
-
+        Logger getInstance(const log4cplus::tstring& name, spi::LoggerFactory& factory);
+        
+        void addAppender(Logger &logger, log4cplus::SharedAppenderPtr& appender);
+        
     private:
       // Data
         Hierarchy& h;
-        thread::Guard hierarchyLocker;
+        log4cplus::thread::MutexGuard hierarchyLocker;
         LoggerList loggerList;
     };
 
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_HIERARCHY_LOCKER_HEADER_
+#endif // DCMTK_LOG4CPLUS_HIERARCHY_LOCKER_HEADER_
 
diff --git a/oflog/include/dcmtk/oflog/internal/cygwin32.h b/oflog/include/dcmtk/oflog/internal/cygwin32.h
new file mode 100644
index 0000000..3105870
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/internal/cygwin32.h
@@ -0,0 +1,56 @@
+// -*- C++ -*-
+// Module:  Log4CPLUS
+// File:    cygwin-win32.h
+// Created: 7/2011
+// Author:  Vaclav Zeman
+//
+//  Copyright (C) 2011, Vaclav Zeman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#if ! defined (DCMTK_LOG4CPLUS_CONFIG_CYGWIN_WIN32_H)
+#define DCMTK_LOG4CPLUS_CONFIG_CYGWIN_WIN32_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#if defined (__CYGWIN__)
+
+#if ! defined (DCMTK_INSIDE_LOG4CPLUS)
+#  error "This header must not be be used outside log4cplus' implementation files."
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace cygwin {
+
+unsigned long get_current_win32_thread_id ();
+
+} } // namespace log4cplus { namespace cygwin {
+} // end namespace dcmtk
+
+
+#endif // defined (__CYGWIN__)
+#endif // DCMTK_LOG4CPLUS_CONFIG_CYGWIN_WIN32_H
diff --git a/oflog/include/dcmtk/oflog/internal/env.h b/oflog/include/dcmtk/oflog/internal/env.h
new file mode 100644
index 0000000..4c1de9a
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/internal/env.h
@@ -0,0 +1,89 @@
+// -*- C++ -*-
+// Module:  Log4CPLUS
+// File:    env.h
+// Created: 7/2010
+// Author:  Vaclav Haisman
+//
+//
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#ifndef DCMTK_LOG4CPLUS_INTERNAL_ENV_H
+#define DCMTK_LOG4CPLUS_INTERNAL_ENV_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/tstring.h"
+
+#if defined (_WIN32)
+#include "dcmtk/oflog/config/windowsh.h"
+#endif
+#ifdef DCMTK_LOG4CPLUS_HAVE_SYS_TYPES_H
+#include <sys/types.h>
+#endif
+#ifdef DCMTK_LOG4CPLUS_HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace internal {
+
+
+bool get_env_var (tstring & value, tstring const & name);
+bool parse_bool (bool & val, tstring const & str);
+
+inline
+#if defined (_WIN32)
+DWORD
+get_process_id ()
+{
+    return GetCurrentProcessId ();
+}
+
+#elif defined (DCMTK_LOG4CPLUS_HAVE_GETPID)
+pid_t
+get_process_id ()
+{
+    return getpid ();
+}
+
+#else
+int
+get_process_id ()
+{
+    return 0; 
+}
+
+#endif
+
+
+} } // namespace log4cplus { namespace internal {
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_INTERNAL_ENV_H
diff --git a/oflog/include/dcmtk/oflog/internal/internal.h b/oflog/include/dcmtk/oflog/internal/internal.h
new file mode 100644
index 0000000..78a84e7
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/internal/internal.h
@@ -0,0 +1,249 @@
+// -*- C++ -*-
+// Module:  Log4CPLUS
+// File:    internal.h
+// Created: 1/2009
+// Author:  Vaclav Haisman
+//
+//
+//  Copyright (C) 2009-2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+/** @file 
+ * This header contains declaration internal to log4cplus. They must never be
+ * visible from user accesible headers or exported in DLL/shared libray.
+ */
+
+
+#ifndef DCMTK_LOG4CPLUS_INTERNAL_INTERNAL_HEADER_
+#define DCMTK_LOG4CPLUS_INTERNAL_INTERNAL_HEADER_
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#if ! defined (DCMTK_INSIDE_LOG4CPLUS)
+#  error "This header must not be be used outside log4cplus' implementation files."
+#endif
+
+#include <memory>
+#include "dcmtk/ofstd/ofvector.h"
+#include <sstream>
+#include <cstdio>
+#include "dcmtk/oflog/tstring.h"
+#include "dcmtk/oflog/streams.h"
+#include "dcmtk/oflog/ndc.h"
+#include "dcmtk/oflog/mdc.h"
+#include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/thread/impl/tls.h"
+#include "dcmtk/oflog/helpers/snprintf.h"
+
+
+namespace dcmtk {
+namespace log4cplus {
+
+namespace internal {
+
+
+//! Canonical empty string. It is used when the need to return empty string
+//! by reference arises.
+extern log4cplus::tstring const empty_str;
+
+
+struct gft_scratch_pad
+{
+    gft_scratch_pad ();
+    ~gft_scratch_pad ();
+    
+    void
+    reset ()
+    {
+        uc_q_str_valid = false;
+        q_str_valid = false;
+        s_str_valid = false;
+        ret.clear ();
+    }
+    
+    log4cplus::tstring q_str;
+    log4cplus::tstring uc_q_str;
+    log4cplus::tstring s_str;
+    log4cplus::tstring ret;
+    log4cplus::tstring fmt;
+    log4cplus::tstring tmp;
+    OFVector<tchar> buffer;
+    bool uc_q_str_valid;
+    bool q_str_valid;
+    bool s_str_valid;
+};
+
+
+struct appender_sratch_pad
+{
+    appender_sratch_pad ();
+    ~appender_sratch_pad ();
+
+    tostringstream oss;
+    tstring str;
+    STD_NAMESPACE string chstr;
+};
+
+
+//! Per thread data.
+struct per_thread_data
+{
+    per_thread_data ();
+    ~per_thread_data ();
+
+    tostringstream macros_oss;
+    tostringstream layout_oss;
+    DiagnosticContextStack ndc_dcs;
+    MappedDiagnosticContextMap mdc_map;
+    log4cplus::tstring thread_name;
+    log4cplus::tstring thread_name2;
+    gft_scratch_pad gft_sp;
+    appender_sratch_pad appender_sp;
+    log4cplus::tstring faa_str;
+    log4cplus::tstring ll_str;
+    spi::InternalLoggingEvent forced_log_ev;
+    FILE * fnull;
+    log4cplus::helpers::snprintf_buf snprintf_buf;
+
+private:
+    per_thread_data (per_thread_data&);
+    per_thread_data& operator=(const per_thread_data&);
+};
+
+
+per_thread_data * alloc_ptd ();
+
+// TLS key whose value is pointer struct per_thread_data.
+extern log4cplus::thread::impl::tls_key_type tls_storage_key;
+
+
+#if ! defined (DCMTK_LOG4CPLUS_SINGLE_THREADED) \
+    && defined (DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR)
+
+extern DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR per_thread_data * ptd;
+
+
+inline
+void
+set_ptd (per_thread_data * p)
+{
+    ptd = p;
+}
+
+
+//! The default value of the \param alloc is false for Win32 DLL builds
+//! since per thread data are already initialized by DllMain().
+inline
+per_thread_data *
+get_ptd (bool alloc
+#if defined (_WIN32) && defined (DCMTK_LOG4CPLUS_BUILD_DLL)
+         = false
+#else
+         = true
+#endif
+         )
+{
+    if (DCMTK_LOG4CPLUS_UNLIKELY (! ptd && alloc))
+        return alloc_ptd ();
+
+    // The assert() does not belong here. get_ptd() might be called by
+    // cleanup code that can handle the returned NULL pointer.
+    //assert (ptd);
+
+    return ptd;
+}
+
+
+#else // defined (DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR)
+
+
+inline
+void
+set_ptd (per_thread_data * p)
+{
+    thread::impl::tls_set_value (tls_storage_key, p);
+}
+
+
+inline
+per_thread_data *
+get_ptd (bool alloc = true)
+{
+    per_thread_data * ptd
+        = OFreinterpret_cast(per_thread_data *,
+            thread::impl::tls_get_value (tls_storage_key));
+
+    if (DCMTK_LOG4CPLUS_UNLIKELY (! ptd && alloc))
+        return alloc_ptd ();
+
+    return ptd;
+}
+
+
+#endif // defined (DCMTK_LOG4CPLUS_THREAD_LOCAL_VAR)
+
+
+inline
+tstring &
+get_thread_name_str ()
+{
+    return get_ptd ()->thread_name;
+}
+
+
+inline
+tstring &
+get_thread_name2_str ()
+{
+    return get_ptd ()->thread_name2;
+}
+
+
+inline
+gft_scratch_pad &
+get_gft_scratch_pad ()
+{
+    return get_ptd ()->gft_sp;
+}
+
+
+inline
+appender_sratch_pad &
+get_appender_sp ()
+{
+    return get_ptd ()->appender_sp;
+}
+
+
+} // namespace internal {
+
+
+} // namespace log4cplus { 
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_INTERNAL_INTERNAL_HEADER_
diff --git a/oflog/include/dcmtk/oflog/internal/socket.h b/oflog/include/dcmtk/oflog/internal/socket.h
new file mode 100644
index 0000000..f24973d
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/internal/socket.h
@@ -0,0 +1,120 @@
+// -*- C++ -*-
+// Module:  Log4CPLUS
+// File:    socket.h
+// Created: 1/2010
+// Author:  Vaclav Haisman
+//
+//
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+/** @file 
+ * This header contains declaration internal to log4cplus. They must never be
+ * visible from user accesible headers or exported in DLL/shared libray.
+ */
+
+
+#ifndef DCMTK_LOG4CPLUS_INTERNAL_SOCKET_H_
+#define DCMTK_LOG4CPLUS_INTERNAL_SOCKET_H_
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#if ! defined (DCMTK_INSIDE_LOG4CPLUS)
+#  error "This header must not be be used outside log4cplus' implementation files."
+#endif
+
+#if defined(_WIN32)
+#include "dcmtk/oflog/config/windowsh.h"
+#endif
+#include "dcmtk/oflog/helpers/socket.h"
+
+#include <cerrno>
+#ifdef DCMTK_LOG4CPLUS_HAVE_ERRNO_H
+#include <errno.h>
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus {
+
+namespace helpers {
+
+
+#if defined(_WIN32)
+typedef SOCKET os_socket_type;
+#else
+typedef int os_socket_type;
+#endif
+
+
+os_socket_type const INVALID_OS_SOCKET_VALUE
+#if defined(_WIN32)
+    = INVALID_SOCKET;
+#else
+    = -1;
+#endif
+
+
+static inline
+os_socket_type
+to_os_socket (SOCKET_TYPE const & x)
+{
+    return OFstatic_cast(os_socket_type, x);
+}
+
+
+static inline
+SOCKET_TYPE
+to_log4cplus_socket (os_socket_type const & x)
+{
+    return OFstatic_cast(SOCKET_TYPE, x);
+}
+
+
+static inline
+void
+set_last_socket_error (int err)
+{
+    errno = err;
+}
+
+
+static inline
+int
+get_last_socket_error ()
+{
+    return errno;
+}
+
+
+} // namespace helpers {
+
+} // namespace log4cplus { 
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_INTERNAL_SOCKET_H_
